#ifndef _H_6D5E16FB8AC2B4748DE2BE76DBFB8E52_People_DCPS_H_
#define _H_6D5E16FB8AC2B4748DE2BE76DBFB8E52_People_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "People_.h"


namespace people_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class People_TypeSupportInterface;

            typedef People_TypeSupportInterface * People_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < People_TypeSupportInterface> People_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < People_TypeSupportInterface> People_TypeSupportInterface_out;


            class People_DataWriter;

            typedef People_DataWriter * People_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < People_DataWriter> People_DataWriter_var;
            typedef DDS_DCPSInterface_out < People_DataWriter> People_DataWriter_out;


            class People_DataReader;

            typedef People_DataReader * People_DataReader_ptr;
            typedef DDS_DCPSInterface_var < People_DataReader> People_DataReader_var;
            typedef DDS_DCPSInterface_out < People_DataReader> People_DataReader_out;


            class People_DataReaderView;

            typedef People_DataReaderView * People_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < People_DataReaderView> People_DataReaderView_var;
            typedef DDS_DCPSInterface_out < People_DataReaderView> People_DataReaderView_out;

            struct People_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < People_, struct People_Seq_uniq_> People_Seq;
            typedef DDS_DCPSSequence_var < People_Seq> People_Seq_var;
            typedef DDS_DCPSSequence_out < People_Seq> People_Seq_out;

            class  People_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef People_TypeSupportInterface_ptr _ptr_type;
                typedef People_TypeSupportInterface_var _var_type;

                static People_TypeSupportInterface_ptr _duplicate (People_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static People_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static People_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static People_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                People_TypeSupportInterface_ptr _this () { return this; }


            protected:
                People_TypeSupportInterface () {};
                ~People_TypeSupportInterface () {};
            private:
                People_TypeSupportInterface (const People_TypeSupportInterface &);
                People_TypeSupportInterface & operator = (const People_TypeSupportInterface &);
            };

            class  People_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef People_DataWriter_ptr _ptr_type;
                typedef People_DataWriter_var _var_type;

                static People_DataWriter_ptr _duplicate (People_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static People_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static People_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static People_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                People_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const People_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const People_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const People_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const People_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const People_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const People_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const People_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const People_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const People_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const People_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (People_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const People_& instance_data) = 0;

            protected:
                People_DataWriter () {};
                ~People_DataWriter () {};
            private:
                People_DataWriter (const People_DataWriter &);
                People_DataWriter & operator = (const People_DataWriter &);
            };

            class  People_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef People_DataReader_ptr _ptr_type;
                typedef People_DataReader_var _var_type;

                static People_DataReader_ptr _duplicate (People_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static People_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static People_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static People_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                People_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (People_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (People_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (People_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (People_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const People_& instance) = 0;

            protected:
                People_DataReader () {};
                ~People_DataReader () {};
            private:
                People_DataReader (const People_DataReader &);
                People_DataReader & operator = (const People_DataReader &);
            };

            class  People_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef People_DataReaderView_ptr _ptr_type;
                typedef People_DataReaderView_var _var_type;

                static People_DataReaderView_ptr _duplicate (People_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static People_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static People_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static People_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                People_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (People_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (People_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (People_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (People_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (People_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const People_& instance) = 0;

            protected:
                People_DataReaderView () {};
                ~People_DataReaderView () {};
            private:
                People_DataReaderView (const People_DataReaderView &);
                People_DataReaderView & operator = (const People_DataReaderView &);
            };
        }

    }

}

#endif
