#ifndef _H_A7F884758F8777FD50102630BF7C3FB0_PersonStamped_DCPS_H_
#define _H_A7F884758F8777FD50102630BF7C3FB0_PersonStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PersonStamped_.h"


namespace people_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PersonStamped_TypeSupportInterface;

            typedef PersonStamped_TypeSupportInterface * PersonStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PersonStamped_TypeSupportInterface> PersonStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PersonStamped_TypeSupportInterface> PersonStamped_TypeSupportInterface_out;


            class PersonStamped_DataWriter;

            typedef PersonStamped_DataWriter * PersonStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PersonStamped_DataWriter> PersonStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < PersonStamped_DataWriter> PersonStamped_DataWriter_out;


            class PersonStamped_DataReader;

            typedef PersonStamped_DataReader * PersonStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PersonStamped_DataReader> PersonStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < PersonStamped_DataReader> PersonStamped_DataReader_out;


            class PersonStamped_DataReaderView;

            typedef PersonStamped_DataReaderView * PersonStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PersonStamped_DataReaderView> PersonStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PersonStamped_DataReaderView> PersonStamped_DataReaderView_out;

            struct PersonStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PersonStamped_, struct PersonStamped_Seq_uniq_> PersonStamped_Seq;
            typedef DDS_DCPSSequence_var < PersonStamped_Seq> PersonStamped_Seq_var;
            typedef DDS_DCPSSequence_out < PersonStamped_Seq> PersonStamped_Seq_out;

            class  PersonStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PersonStamped_TypeSupportInterface_ptr _ptr_type;
                typedef PersonStamped_TypeSupportInterface_var _var_type;

                static PersonStamped_TypeSupportInterface_ptr _duplicate (PersonStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PersonStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PersonStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PersonStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PersonStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PersonStamped_TypeSupportInterface () {};
                ~PersonStamped_TypeSupportInterface () {};
            private:
                PersonStamped_TypeSupportInterface (const PersonStamped_TypeSupportInterface &);
                PersonStamped_TypeSupportInterface & operator = (const PersonStamped_TypeSupportInterface &);
            };

            class  PersonStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PersonStamped_DataWriter_ptr _ptr_type;
                typedef PersonStamped_DataWriter_var _var_type;

                static PersonStamped_DataWriter_ptr _duplicate (PersonStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PersonStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PersonStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PersonStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PersonStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PersonStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PersonStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PersonStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PersonStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PersonStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PersonStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PersonStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PersonStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PersonStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PersonStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PersonStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PersonStamped_& instance_data) = 0;

            protected:
                PersonStamped_DataWriter () {};
                ~PersonStamped_DataWriter () {};
            private:
                PersonStamped_DataWriter (const PersonStamped_DataWriter &);
                PersonStamped_DataWriter & operator = (const PersonStamped_DataWriter &);
            };

            class  PersonStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PersonStamped_DataReader_ptr _ptr_type;
                typedef PersonStamped_DataReader_var _var_type;

                static PersonStamped_DataReader_ptr _duplicate (PersonStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PersonStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PersonStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PersonStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PersonStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PersonStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PersonStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PersonStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PersonStamped_& instance) = 0;

            protected:
                PersonStamped_DataReader () {};
                ~PersonStamped_DataReader () {};
            private:
                PersonStamped_DataReader (const PersonStamped_DataReader &);
                PersonStamped_DataReader & operator = (const PersonStamped_DataReader &);
            };

            class  PersonStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PersonStamped_DataReaderView_ptr _ptr_type;
                typedef PersonStamped_DataReaderView_var _var_type;

                static PersonStamped_DataReaderView_ptr _duplicate (PersonStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PersonStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PersonStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PersonStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PersonStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PersonStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PersonStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PersonStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PersonStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PersonStamped_& instance) = 0;

            protected:
                PersonStamped_DataReaderView () {};
                ~PersonStamped_DataReaderView () {};
            private:
                PersonStamped_DataReaderView (const PersonStamped_DataReaderView &);
                PersonStamped_DataReaderView & operator = (const PersonStamped_DataReaderView &);
            };
        }

    }

}

#endif
