#ifndef _H_57483CFACF64E0F17103F0AA7889712B_PositionMeasurementArray_DCPS_H_
#define _H_57483CFACF64E0F17103F0AA7889712B_PositionMeasurementArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionMeasurementArray_.h"


namespace people_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionMeasurementArray_TypeSupportInterface;

            typedef PositionMeasurementArray_TypeSupportInterface * PositionMeasurementArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurementArray_TypeSupportInterface> PositionMeasurementArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionMeasurementArray_TypeSupportInterface> PositionMeasurementArray_TypeSupportInterface_out;


            class PositionMeasurementArray_DataWriter;

            typedef PositionMeasurementArray_DataWriter * PositionMeasurementArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurementArray_DataWriter> PositionMeasurementArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionMeasurementArray_DataWriter> PositionMeasurementArray_DataWriter_out;


            class PositionMeasurementArray_DataReader;

            typedef PositionMeasurementArray_DataReader * PositionMeasurementArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurementArray_DataReader> PositionMeasurementArray_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionMeasurementArray_DataReader> PositionMeasurementArray_DataReader_out;


            class PositionMeasurementArray_DataReaderView;

            typedef PositionMeasurementArray_DataReaderView * PositionMeasurementArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurementArray_DataReaderView> PositionMeasurementArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionMeasurementArray_DataReaderView> PositionMeasurementArray_DataReaderView_out;

            struct PositionMeasurementArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PositionMeasurementArray_, struct PositionMeasurementArray_Seq_uniq_> PositionMeasurementArray_Seq;
            typedef DDS_DCPSSequence_var < PositionMeasurementArray_Seq> PositionMeasurementArray_Seq_var;
            typedef DDS_DCPSSequence_out < PositionMeasurementArray_Seq> PositionMeasurementArray_Seq_out;

            class  PositionMeasurementArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionMeasurementArray_TypeSupportInterface_ptr _ptr_type;
                typedef PositionMeasurementArray_TypeSupportInterface_var _var_type;

                static PositionMeasurementArray_TypeSupportInterface_ptr _duplicate (PositionMeasurementArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurementArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurementArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionMeasurementArray_TypeSupportInterface () {};
                ~PositionMeasurementArray_TypeSupportInterface () {};
            private:
                PositionMeasurementArray_TypeSupportInterface (const PositionMeasurementArray_TypeSupportInterface &);
                PositionMeasurementArray_TypeSupportInterface & operator = (const PositionMeasurementArray_TypeSupportInterface &);
            };

            class  PositionMeasurementArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionMeasurementArray_DataWriter_ptr _ptr_type;
                typedef PositionMeasurementArray_DataWriter_var _var_type;

                static PositionMeasurementArray_DataWriter_ptr _duplicate (PositionMeasurementArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurementArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurementArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionMeasurementArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionMeasurementArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionMeasurementArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionMeasurementArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionMeasurementArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionMeasurementArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionMeasurementArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionMeasurementArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionMeasurementArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionMeasurementArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionMeasurementArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionMeasurementArray_& instance_data) = 0;

            protected:
                PositionMeasurementArray_DataWriter () {};
                ~PositionMeasurementArray_DataWriter () {};
            private:
                PositionMeasurementArray_DataWriter (const PositionMeasurementArray_DataWriter &);
                PositionMeasurementArray_DataWriter & operator = (const PositionMeasurementArray_DataWriter &);
            };

            class  PositionMeasurementArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionMeasurementArray_DataReader_ptr _ptr_type;
                typedef PositionMeasurementArray_DataReader_var _var_type;

                static PositionMeasurementArray_DataReader_ptr _duplicate (PositionMeasurementArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurementArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurementArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionMeasurementArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionMeasurementArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionMeasurementArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionMeasurementArray_& instance) = 0;

            protected:
                PositionMeasurementArray_DataReader () {};
                ~PositionMeasurementArray_DataReader () {};
            private:
                PositionMeasurementArray_DataReader (const PositionMeasurementArray_DataReader &);
                PositionMeasurementArray_DataReader & operator = (const PositionMeasurementArray_DataReader &);
            };

            class  PositionMeasurementArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionMeasurementArray_DataReaderView_ptr _ptr_type;
                typedef PositionMeasurementArray_DataReaderView_var _var_type;

                static PositionMeasurementArray_DataReaderView_ptr _duplicate (PositionMeasurementArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurementArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurementArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurementArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionMeasurementArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionMeasurementArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionMeasurementArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionMeasurementArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionMeasurementArray_& instance) = 0;

            protected:
                PositionMeasurementArray_DataReaderView () {};
                ~PositionMeasurementArray_DataReaderView () {};
            private:
                PositionMeasurementArray_DataReaderView (const PositionMeasurementArray_DataReaderView &);
                PositionMeasurementArray_DataReaderView & operator = (const PositionMeasurementArray_DataReaderView &);
            };
        }

    }

}

#endif
