#ifndef _H_C85E1879372BDB13CC1A0B7B18A8EA27_PositionMeasurement__H_
#define _H_C85E1879372BDB13CC1A0B7B18A8EA27_PositionMeasurement__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"


namespace people_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  PositionMeasurement_
            {
                struct _covariance__uniq_{};
                typedef ::DDS::Double _covariance__slice;
                typedef ::DDS::Double _covariance_[9];
                typedef DDS_DCPS_FArray_var< _covariance_, _covariance__slice, struct _covariance__uniq_ > _covariance__var;
                typedef _covariance_ _covariance__out;
                typedef DDS_DCPS_Array_forany< _covariance_, _covariance__slice, struct _covariance__uniq_ > _covariance__forany;
                static _covariance__slice *_covariance__alloc();
                static void _covariance__free(_covariance__slice *);
                static void _covariance__copy(_covariance__slice *to, const _covariance__slice *from);
                static _covariance__slice *_covariance__dup(const _covariance__slice *from);
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr name_;
                ::DDS::String_mgr object_id_;
                ::geometry_msgs::msg::dds_::Point_ pos_;
                ::DDS::Double reliability_;
                _covariance_ covariance_;
                ::DDS::Octet initialization_;
            };

            typedef DDS_DCPSStruct_var<PositionMeasurement_> PositionMeasurement__var;
            typedef DDS_DCPSStruct_out < PositionMeasurement_> PositionMeasurement__out;

        }

    }

}

#endif /* _H_C85E1879372BDB13CC1A0B7B18A8EA27_PositionMeasurement__H_ */
