#ifndef _H_C85E1879372BDB13CC1A0B7B18A8EA27_PositionMeasurement_DCPS_H_
#define _H_C85E1879372BDB13CC1A0B7B18A8EA27_PositionMeasurement_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionMeasurement_.h"


namespace people_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionMeasurement_TypeSupportInterface;

            typedef PositionMeasurement_TypeSupportInterface * PositionMeasurement_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurement_TypeSupportInterface> PositionMeasurement_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionMeasurement_TypeSupportInterface> PositionMeasurement_TypeSupportInterface_out;


            class PositionMeasurement_DataWriter;

            typedef PositionMeasurement_DataWriter * PositionMeasurement_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurement_DataWriter> PositionMeasurement_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionMeasurement_DataWriter> PositionMeasurement_DataWriter_out;


            class PositionMeasurement_DataReader;

            typedef PositionMeasurement_DataReader * PositionMeasurement_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurement_DataReader> PositionMeasurement_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionMeasurement_DataReader> PositionMeasurement_DataReader_out;


            class PositionMeasurement_DataReaderView;

            typedef PositionMeasurement_DataReaderView * PositionMeasurement_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionMeasurement_DataReaderView> PositionMeasurement_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionMeasurement_DataReaderView> PositionMeasurement_DataReaderView_out;

            struct PositionMeasurement_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PositionMeasurement_, struct PositionMeasurement_Seq_uniq_> PositionMeasurement_Seq;
            typedef DDS_DCPSSequence_var < PositionMeasurement_Seq> PositionMeasurement_Seq_var;
            typedef DDS_DCPSSequence_out < PositionMeasurement_Seq> PositionMeasurement_Seq_out;

            class  PositionMeasurement_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionMeasurement_TypeSupportInterface_ptr _ptr_type;
                typedef PositionMeasurement_TypeSupportInterface_var _var_type;

                static PositionMeasurement_TypeSupportInterface_ptr _duplicate (PositionMeasurement_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurement_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurement_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurement_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurement_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionMeasurement_TypeSupportInterface () {};
                ~PositionMeasurement_TypeSupportInterface () {};
            private:
                PositionMeasurement_TypeSupportInterface (const PositionMeasurement_TypeSupportInterface &);
                PositionMeasurement_TypeSupportInterface & operator = (const PositionMeasurement_TypeSupportInterface &);
            };

            class  PositionMeasurement_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionMeasurement_DataWriter_ptr _ptr_type;
                typedef PositionMeasurement_DataWriter_var _var_type;

                static PositionMeasurement_DataWriter_ptr _duplicate (PositionMeasurement_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurement_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurement_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurement_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurement_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionMeasurement_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionMeasurement_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionMeasurement_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionMeasurement_& instance_data) = 0;

            protected:
                PositionMeasurement_DataWriter () {};
                ~PositionMeasurement_DataWriter () {};
            private:
                PositionMeasurement_DataWriter (const PositionMeasurement_DataWriter &);
                PositionMeasurement_DataWriter & operator = (const PositionMeasurement_DataWriter &);
            };

            class  PositionMeasurement_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionMeasurement_DataReader_ptr _ptr_type;
                typedef PositionMeasurement_DataReader_var _var_type;

                static PositionMeasurement_DataReader_ptr _duplicate (PositionMeasurement_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurement_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurement_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurement_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurement_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionMeasurement_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionMeasurement_& instance) = 0;

            protected:
                PositionMeasurement_DataReader () {};
                ~PositionMeasurement_DataReader () {};
            private:
                PositionMeasurement_DataReader (const PositionMeasurement_DataReader &);
                PositionMeasurement_DataReader & operator = (const PositionMeasurement_DataReader &);
            };

            class  PositionMeasurement_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionMeasurement_DataReaderView_ptr _ptr_type;
                typedef PositionMeasurement_DataReaderView_var _var_type;

                static PositionMeasurement_DataReaderView_ptr _duplicate (PositionMeasurement_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionMeasurement_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionMeasurement_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionMeasurement_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionMeasurement_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionMeasurement_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionMeasurement_& instance) = 0;

            protected:
                PositionMeasurement_DataReaderView () {};
                ~PositionMeasurement_DataReaderView () {};
            private:
                PositionMeasurement_DataReaderView (const PositionMeasurement_DataReaderView &);
                PositionMeasurement_DataReaderView & operator = (const PositionMeasurement_DataReaderView &);
            };
        }

    }

}

#endif
